import processing.core.*; 
import processing.xml.*; 

import traer.physics.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class MagneticMaterials extends PApplet {

 //used in the thermic vibration

//constants used in thermic vibration
ParticleSystem physics;
Particle[][] particles;
  Particle[][] lattice;

float[][] ferroAngle;

int gridSize = 6;
float SPRING_STRENGTH = 0.005f;
float SPRING_DAMPING = 0.01f;
float gridStepX = 22;
float gridStepY = 22;

int step = 0; //animation step 
boolean toggleText = false; //first run give us the currrent step in the first hysteretic cycle 
boolean toggleDomain = false; //shows the magnetic domain structure for the ferromagnetics 

PGraphics pg; //Buffers for every step  
PGraphics Wall; //P3D buffer used for drawing the domain wall
PGraphics graphSmall; //draws graphs
//PGraphics graph;
PFont f;
PFont  fontTitle;

Button back,MagMat1, MagMat2, MagMat3;//Buttons
boolean toggleGraph = true; 
String[] formula1 = {
  "B*", "=","\u03bc_0","H*","+", "\u03bc_0", "M*"
};

//String[] items = {"1.:Introdu\u00e7\u00e3o","2.:Materiais magn\u00e9ticos","3.:Dom\u00ednios Magneticos","4.:Curva de Magnetiza\u00e7\u00e3o","5.:Curva de Histerese"};
float xcursor, ycursor;
float t;
String[] explica1 = {
  "Indu\u00e7\u00e3o\nMagn\u00e9tica","", "Permeabilidade\nMagn\u00e9tica do v\u00e1cuo","Campo Magn\u00e9tico\nExterno","", "Permeabilidade\nMagn\u00e9tica do v\u00e1cuo", "Magnetiza\u00e7\u00e3o"
};

int showWall=0;
int MagMat = 2;


//TEMPERATURE
float T=300;
Scrollbar Temp;
Scrollbar Vert;
float angle = 0;
float mod = 0;

PImage mask;
PFont fontButton;
textBox showText;

Credito credito;  //credit

int lang = 0; //language

public void setup() {
  size(600,650, JAVA2D);  
  hint(ENABLE_NATIVE_FONTS);  
  frameRate(16);
  
  //BUTTONS AND LISTENERS
  //PGraphics _layer, float _dxoffset, float _dyoffset, int _x, int _y, 
  // int _TWidth, int _THeight, String _defaulttext, int _Border, float _Margin, color _TColour)
  setText();
  
  back = new Button(515,525,70,30, polyScreen[0][lang], true);
  MagMat1 = new Button(210,204-80,320,132,"",false);
  MagMat2 = new Button(210,350-78,320,132,"",false );
  MagMat3 = new Button(210,496-75,320,132,"", false );


  //SCROLLBAR
  //Scrollbar (int xp, int yp, int sw, int sh, int l) {
  Temp = new Scrollbar(480, 360, 140,10, 3, 10,10); 

  //Vert = new Scrollbar(440, 120, 10, 80, 3);
  Temp.newspos = 415;
  fontButton = loadFont("ArialNarrow-Bold-24.vlw");
  fontTitle = loadFont("ArialUnicodeMS-72.vlw");
  f = loadFont("ArialUnicodeMS-24.vlw");
  showText = new textBox(225,420, 310, 200, "", f, 14,10, 140); 
  
  //(float _x, float _y, float _width,float _height, String _texto, PFont _font, int _fontsize, float _sWidth, float _sHeight) 
  //creating the traer.physical used to represent thermic vibration 
  physics = new ParticleSystem(0.1f, 0.01f);
  particles = new Particle[gridSize][gridSize];
  lattice = new Particle[gridSize][gridSize];
  ferroAngle = new float[gridSize][gridSize];

  for (int i = 0; i < gridSize; i++)
  {
    for (int j = 0; j < gridSize; j++)
    {
      particles[i][j] = physics.makeParticle(0.2f, j * gridStepX+20, i * gridStepY+20, 0.0f);
      lattice[i][j] = physics.makeParticle(0.2f, j * gridStepX+20, i * gridStepY+20, 0.0f);
      ferroAngle[i][j] = cos(i*j)*random(-3,3);
      if (j > 0)
      {
        physics.makeSpring(particles[i][j - 1], particles[i][j], SPRING_STRENGTH, SPRING_DAMPING, gridStepX);
      }
      physics.makeSpring(lattice[i][j], particles[i][j], SPRING_STRENGTH, SPRING_DAMPING, 0);
      lattice[i][j].makeFixed();
    }
  }
  for (int j = 0; j < gridSize; j++)
  {
    for (int i = 1; i < gridSize; i++)
    {
      physics.makeSpring(particles[i - 1][j], particles[i][j], SPRING_STRENGTH, SPRING_DAMPING, gridStepY);
    }
  }
  physics.setGravity(0);
  randomSeed(3);

  mask = loadImage("mask.png");
  pg= createGraphics(150,150, JAVA2D);
  Wall = createGraphics(200,200,P3D);
  graphSmall = createGraphics(100,100, JAVA2D);

  //dominios = loadImage("dominio.png");
  smooth();

  credito= new Credito();


}

public void draw() {
  //rectMode(CENTER);
     background(255);
    fill(0);
    ////////////////SPLASH SCREEN////////////////////
  textFont(fontTitle);
  textAlign(CENTER);

  //textLeading(16);
  textSize(32);
    fill(31,142,0);
  text(polyScreen[1][lang], width/2, 40);
  fill(0);
  textSize(13); 
  textLeading(13);
  text(polyExplain[7][lang]
    ,  width/2,510);


  textAlign(LEFT);       
  textFont(fontButton,16);
  text(polyScreen[2][lang],50,150-80);     
  text(polyScreen[3][lang],50,295-78);
  text(polyScreen[4][lang], 50,440-75);
  textFont(f, 12);
  textLeading(12);
  
  text(polyExplain[0][lang],140,150, 180,150);    
  text(polyExplain[1][lang],140,295, 180,150);  
  text(polyExplain[2][lang],140,440, 180,150);  

  /*if(T> Tc) 
   text("Para temperaturas acima da "+
   "temperatura de Curie, a vibra\u00e7\u00e3o t\u00e9rmica "+ 
   "suplanta a tend\u00eancia dos momentos magn\u00e9ticos dos "+
   "\u00e1tomos a se alinharem, e o material passa a se comportar " +
   "como um paramagn\u00e9tico"   ,Temp.xpos-20, Temp.ypos+80, 120,150);  */

  //text("Nesta anima\u00e7\u00e3o, exploraremos diferentes t\u00f3picos\nenvolvendo as propriedades magn\u00e9ticas dos materiais", width/2, 90);    
  textFont(fontButton,14);
  textLeading(14);
  textAlign(LEFT); 
  
//writeText();

  T= 1200*(Temp.getPos()+0.1f);
  
  if(step == 0) {////////////////////////0
    imageMode(CORNER); 

    //animating and drawing the atoms 
    //println(int(millis())/10);
    
    physics.tick();
    randomSeed(millis());
    for (int j = 0; j < gridSize; j++) {
      for (int i = 1; i < gridSize; i++) {
        particles[i][j].velocity().add(random(-0.0002f*(T+200)/15,0.0002f*(T+200)/15), random(-0.0002f*(T+200)/15,0.0002f*(T+200)/15), 0);
      }
    }

    randomSeed(3);

    pg.background(255);
    for (int i = 0; i < gridSize; i++) {
      for (int j = 0; j < gridSize; j++) {
        //I need to give a larger freedom to each atom. Let's rock
        atom(particles[i][j].position().x(), particles[i][j].position().y(), 20.0f, angle,T,0,i,j, pg);
        //void atom(float x, float y, float r,  float magDir, float T, int MagMat, PGraphics pg) {
      }
    }

    //drawing the atoms
    image(pg, width/3+30, 130-80, 150, 150);

    pg.background(255);
    for (int i = 0; i < gridSize; i++) {
      for (int j = 0; j < gridSize; j++) {
        //I need to give a larger freedom to each atom. Let's rock
        atom(particles[i][j].position().x(), particles[i][j].position().y(), 20.0f, angle,T,1,i,j, pg);
        //void atom(float x, float y, float r,  float magDir, float T, int MagMat, PGraphics pg) {
      }
    }

    //drawing the atoms
    image(pg, width/3+30, 275-78, 150, 150);

    pg.background(255);
    for (int i = 0; i < gridSize; i++) {
      for (int j = 0; j < gridSize; j++) {
        //I need to give a larger freedom to each atom. Let's rock
        atom(particles[i][j].position().x(), particles[i][j].position().y(), 20.0f, angle,T, 2,i,j, pg);
        //void atom(float x, float y, float r,  float magDir, float T, int MagMat, PGraphics pg) {
      }
    }

    //drawing the atoms
    image(pg, width/3+30, 420-75, 150, 150);
  }
  //controlling the temperature with a slider
  //    image(explanation, 300,34);

  ///////////////MAGNETIC MATERIALS//////////
  if(step==1) {         //////////////////////1
    rectMode(CORNERS);
    noStroke();
    fill(150,150);
    rect(0,0,width, height);
    fill(255);
   rect(40, 55, 560, 550);

   rect(400, 55, 560, 550); 

    //animating and drawing the atoms 
    //println(int(millis())/10);
    physics.tick();
    randomSeed(millis());
    for (int j = 0; j < gridSize; j++) {
      for (int i = 1; i < gridSize; i++) {
        particles[i][j].velocity().add(random(-0.0002f*T/300,0.0002f*T/300), random(-0.0002f*T,0.0002f*T), 0);
      }
    }
    randomSeed(3);
    pg.background(255);
    for (int i = 0; i < gridSize; i++) {
      for (int j = 0; j < gridSize; j++) {
        //I need to give a larger freedom to each atom. Let's rock
        atom(particles[i][j].position().x(), particles[i][j].position().y(), 20.0f, angle,T,MagMat,i,j, pg);
        //void atom(float x, float y, float r,  float magDir, float T, int MagMat, PGraphics pg) {
      }
    }
    //drawing the atoms
  
      imageMode(CENTER);
      image(pg, width/2-70, 205, 220,220);


    showText.display();
    textAlign(CENTER);
    textLeading(14);
    textSize(18);  
    fill(0); 

    if(MagMat==0) {
      textFont(fontTitle);
      textAlign(CENTER);
      imageMode(CORNER);
      textLeading(16);
      textSize(32);
      fill(31,42,0);
      text(  polyScreen[2][lang] , width/2-70, 90);  
      fill(0);

      showText.countLines=105;
      showText.texto = 
      polyExplain[4][lang];
    }
    
    if(MagMat==1) {
      textFont(fontTitle);
      textSize(32);
      text(  polyScreen[3][lang], width/2-70, 90);  
      textAlign(CENTER);
      showText.countLines=350;
      showText.texto= polyExplain[5][lang];
    }

    if(MagMat==2) {
      textFont(fontTitle);
      textSize(32);
      textAlign(CENTER);
      text(  polyScreen[4][lang], width/2-70, 90);  
      textSize(12);
      showText.countLines=1010;
      showText.texto= polyExplain[6][lang];
    }
  }
  //controling and showingthe external field H
  textFont(fontButton,14);
  textAlign(CENTER);
  textLeading(14);
  fill(0);
  text(polyScreen[5][0], 480, 140);
  vector(480,240,140);      
  if((step==0)||(MagMat==2)) {
    textAlign(CENTER);
    variable("T_c", polyExplain[3][lang], 511,387, 16, 430,393,0, 0);
    arrowline( 514, 375,  514, 362, g);
  }
  
  
  manageButtons();
  fill(0);
  textFont(fontButton,14);
  textLeading(14);
  textAlign(LEFT);
  text(polyScreen[6][lang], Temp.xpos-50, Temp.ypos-10);
  if(T<400) text(polyScreen[7][lang], Temp.xpos+25, Temp.ypos-10);
  if((T>=400)&&(T<900)) text(polyScreen[8][lang], Temp.xpos+25, Temp.ypos-10);
  if(T>=900) text(polyScreen[9][lang], Temp.xpos+25, Temp.ypos-10);
  Temp.update();
  Temp.display();
  pushStyle();
  credito.display();
  popStyle();
}

//controls the buttons
public void manageButtons() {
  if(step==1) back.display();
  back.update();

  if(step == 0) {
     showText.yScroll.newspos = 390;
    rectMode(CENTER);
    stroke(0,12);
    //MagMat1.display();
    MagMat1.update();
    if(MagMat1.over) {
      fill(200,10);
      rect(210,204-80,320,132);
    }

    //MagMat2.display();
    MagMat2.update();
    if(MagMat2.over) {
      fill(200,10);
      rect(210,350-78,320,132);
    }        

    //MagMat3.display();
    MagMat3.update();
    if(MagMat3.over) {
      fill(200,10);
      rect(210,496-75,320,132);
    }
  }
}
int checkcurve= 1;


public void mousePressed() {
  if(step==0) credito.mousePressed();
  println(mouseX +"+"+ mouseY);
  //if((nextMagMat.press())&&(MagMat<2)) MagMat++;
  //if((backMagMat.press())&&(MagMat>0)) MagMat--;
  if(!credito.showCred) {
    if(step == 0) {
      if(MagMat1.press()) {
        step = 1;
        MagMat = 0;
      }
      if(MagMat2.press()) {
        step =1;
        MagMat = 1;
      }
      if(MagMat3.press()) {
        step = 1;
        MagMat = 2;
      }
    }

    if(step!=0) {
      if(back.press()) {
        step=0;
        //  L.setOpen (false);
      }
    }
  }
}


public void mouseReleased() {
  credito.mouseReleased();
  back.release();
  MagMat1.release();
  MagMat2.release();
  MagMat3.release();
}


public void arrow(float x,  float y, float radius, float angle,PGraphics pg) {
  pg.beginDraw();
  if((radius<5)) {
    pg.fill(0); 
    pg.ellipse(x,y, 4,4);
  }
  else {
    pg.pushMatrix();
    pg.translate(x, y);
    // pg.translate((x+cos(angle)*radius)/2, (y+sin(angle)*radius)/2);
    pg.rotate(angle);
    pg.line(-radius/2, 0, radius/2, 0);
    if (radius>=0) {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, -3, -6);
      pg.line(0, 0, 3, -6);
    }
    else {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, 3, 6);
      pg.line(0, 0, -3, 6);
    }          
    pg.popMatrix();
  }
  pg.endDraw();
} 

public void arrow0(float x,  float y, float radius, float angle,PGraphics pg) {
  pg.beginDraw();
  if(abs(radius)>4) {
    pg.pushMatrix();
    pg.translate(x, y);
    // pg.translate((x+cos(angle)*radius)/2, (y+sin(angle)*radius)/2);
    pg.rotate(angle);
    pg.line(-radius/2, 0, radius/2, 0);
    if (radius>=0) {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, -3, -6);
      pg.line(0, 0, 3, -6);
    }
    else {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, 3, 6);
      pg.line(0, 0, -3, 6);
    }          
    pg.popMatrix();

    pg.endDraw();
  }
} 

public void arrow0_(float x,  float y, float radius, float angle,PGraphics pg) {
  pg.beginDraw();
  if(abs(radius)>4) {
    pg.pushMatrix();
    pg.translate(x, y);
    // pg.translate((x+cos(angle)*radius)/2, (y+sin(angle)*radius)/2);
    pg.rotate(angle);
    pg.line(-radius/2, 0, radius/2, 0);
    if (radius>=0) {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, -3, -6);
      pg.line(0, 0, 3, -6);
    }
    else {
      pg.translate(radius/2, 0);
      pg.rotate(-PI/2);
      pg.line(0, 0, 3, 6);
      pg.line(0, 0, -3, 6);
    }          
    pg.popMatrix();
  }
  else {
    pg.fill(0); 
    pg.ellipse(x,y, 4,4);
  }
  pg.endDraw();
}     


public void arrowline(float x1, float  y1, float x2,float y2, PGraphics pg) {
  pg.beginDraw();      
  if(dist(x1,y1,x2,y2)>5) {
     pg.line(x1, y1, x2, y2);
    pg.pushMatrix();
    pg.translate(x2, y2);
    float a = atan2(x1-x2, y2-y1);
    pg.rotate(a);

    pg.line(0, 0, -3, -6);
    pg.line(0, 0, 3, -6);
    pg.popMatrix();
  }
  pg.endDraw();
} 

public void arrowline_(float x1, float  y1, float x2,float y2, PGraphics pg) {
  pg.beginDraw();      
  if(dist(x1,y1,x2,y2)>5) {
     pg.line(x1, y1, x2, y2);
    pg.pushMatrix();
    pg.translate(x2, y2);
    float a = atan2(x1-x2, y2-y1);
    pg.rotate(a);

    pg.line(0, 0, -3, -6);
    pg.line(0, 0, 3, -6);
    pg.popMatrix();
  }else{
        pg.fill(0); 
    pg.ellipse(x1,y1, 4,4);
  }
  pg.endDraw();
} 
float Tc = 1043; //Curie Temperature

//ok, gonna create the potential field ferroAngles e ferroX to handle exchange 

public void atom(float x, float y, float r,  float magDir, float T, int MagMat, int i, int j, PGraphics pg) {
  //arrow(x, y, r/1.6, magDir);  
  pg.beginDraw();
  pg.fill(255); 
  pg.stroke(0);
  pg.smooth();
  pg.strokeWeight(1);
  if(MagMat==0) pg.fill(226, 234,0, 30);
  if(MagMat==1) pg.fill(230, 30);
  if(MagMat==2) pg.fill(120, 230,100, 30);
 
  pg.ellipse(x, y, r, r);

  //1: Diamagnetic
  if(MagMat ==0) {
    if(mod<1) {
      // mod=0;
    }
    else if((mod>=1)&&(mod<=13)) {
      //  println(magDir); 
      arrow0(x, y,  -r/1.6f,(random(-3,3))/(4*mod)+magDir, pg);
      // else arrow(x, y,  r/1.6,magDir + random(0,(60-mod)/30), pg);
    } 
    else {
      arrow0(x, y, -r/1.6f,magDir, pg);
    }
  }  
  //0:Paramagnetic   
  if(MagMat == 1) {
    if(mod<1) {
      mod=0;
      arrow(x, y,  r/1.6f,random(-3,3)*(particles[i][j].velocity().y())*15+random(-3,3), pg);//arrow(x, y,  r/1.6,random(-particles[i][j].velocity().x()*random(i+j+20)/16,particles[i][j].velocity().x()*random(i+j+20)/16)*T/50, pg);
    }
 
    //I have to implement the curie law
    else if((mod>=1)&&(mod<=11)) {
      //    println(magDir); 
      arrow(x, y,  r/1.6f,(random(-3,3)*(particles[i][j].velocity().y())*15+random(-3,3))*T/(1000*mod)+magDir, pg);
      // else arrow(x, y,  r/1.6,magDir + random(0,(60-mod)/30), pg);
    } 
    else {
      arrow(x, y, r/1.6f,magDir, pg);
    }
  }

  //2: Ferromagnetic
  if(MagMat == 2) {
    // text(Temp.getPos(), 300,400);
    if(T<Tc) {
      if(mod<5) {
        arrow(x, y,  r/1.6f,magDir, pg);
      }
      
      else arrow(x, y,  r/1.6f,magDir+0.008f*random(0.8f*(T/Tc),1.2f*(T/Tc)), pg);
    }
   else {
    if(mod<1) {
      mod=0;
      arrow(x, y,  r/1.6f,random(-3,3)*(particles[i][j].velocity().y())*15+random(-3,3), pg);//arrow(x, y,  r/1.6,random(-particles[i][j].velocity().x()*random(i+j+20)/16,particles[i][j].velocity().x()*random(i+j+20)/16)*T/50, pg);
    }
 
    //I have to implement the curie law
    else if((mod>=1)&&(mod<=11)) {
      //    println(magDir); 
      arrow(x, y,  r/1.6f,(random(-3,3)*(particles[i][j].velocity().y())*15+random(-3,3))*T/(1000*mod)+magDir, pg);
      // else arrow(x, y,  r/1.6,magDir + random(0,(60-mod)/30), pg);
    } 
    else {
      arrow(x, y, r/1.6f,magDir, pg);
    }
  }
  }
  pg.endDraw();
}

class Button {
  int x, y; // The x- and y-coordinates
  int width, height; // Dimension (width and height)
  boolean over = false; // True when the mouse is over
  boolean pressed = false; // True when the mouse is over and pressed
  String texto;
  float c = 1.65f, b = 3.5f;
  int fontsize;
  int lines, cols; // aux counter vars for fontsize determination (from text string)
  boolean show;
  int Color=color(0); //color of the letters
  
  Button(int xp, int yp, int width, int height,String texto, boolean show) {
    x = xp;
    y = yp;
    this.width =  width;
    this.height = height;
    this.texto = texto; 
    this.show = show;
    fontsize = 14;
    //CalculateFont();
  }
    
  public void CalculateFont() {    
   String [] TMPBuffer = splitTokens(texto, "\n"); // store BText in temporary var, split in lines, to determine fontsize 
    cols = 0;
    for (lines = 0; lines < TMPBuffer.length; lines++) {
      if (TMPBuffer[lines].length() > cols) cols = TMPBuffer[lines].length();
    }
    fontsize = round(c*width / cols);
    if (fontsize > round(height / lines)) fontsize = round(height/lines);
  }
  
  // Updates the over field every frame
  public void update() {
    if ((mouseX >= x-width/2) && (mouseX <= x+width/2) &&
      (mouseY >= y-height/2) && (mouseY <= y+height/2)) {
      over = true;
    } 
    else {
      over = false;
    }
  }
//problemas a vista
  public boolean press() {
    if (over == true) {
      pressed = true;
      return true;
    } 
    else {
      return false;
    }
  }

  public void release() {
    pressed = false; // Set to false when the mouse is released
    fill(0);
  }

  public void display() {
    pushStyle();
   if(show == true){ 
   int shade,light,plateau,selected,TMPcolor;
    
    plateau = TMPcolor = color(0xffAAAAAA);
    shade = lerpColor(0xff000000, plateau, 0.8f);
    light = lerpColor(0xffFFFFFF, plateau, 0.8f);
    selected = color(255-red(plateau), 255-green(plateau), 255-blue(plateau));
    beginShape(QUADS);
    noStroke();

    if (pressed == true) {
      fill(lerpColor(selected, light, 0.9f));
    } 
    else if (over == true) {
     fill(light);
    } 
    else {
      fill(shade);
    }
    vertex(x - (width + b)/2, y - (height + b)/2);
    vertex(x - (width)/2, y - (height)/2);
    vertex(x - (width)/2, y + (height)/2);
    vertex(x - (width + b)/2, y + (height + b)/2);
    
    vertex(x - (width + b)/2, y + (height + b)/2);
    vertex(x - (width)/2, y + (height)/2);
    vertex(x + (width)/2, y + (height)/2);
    vertex(x + (width + b)/2, y + (height + b)/2);
    
   if (pressed == true) {
      fill(lerpColor(selected, shade, 0.9f));
    } 
    else if (over == true) {
      fill(shade);
    } 
    else {
      fill(light);
    }
    vertex(x - (width + b)/2, y - (height + b)/2);
    vertex(x - (width)/2, y - (height)/2);
    vertex(x + (width)/2, y - (height)/2);
    vertex(x + (width + b)/2, y - (height + b)/2);
    
    vertex(x + (width + b)/2, y - (height + b)/2);
    vertex(x + (width)/2, y - (height)/2);
    vertex(x + (width)/2, y + (height)/2);
    vertex(x + (width + b)/2, y + (height + b)/2);
    endShape();
    
    if (pressed == true) {
      fill(lerpColor(selected, shade, 0.5f));
    } 
    else if (over == true) {
      fill( lerpColor(shade, plateau, 0.7f));
    } 
    else {
      fill(plateau);
    }
    rectMode(CENTER);
    rect(x, y, width, height);

 
   if (pressed == true) {
      fill(lerpColor( color((brightness(TMPcolor) > 128) ? (0) : (255)) , TMPcolor, 0.7f));
    } 
    else if (over == true) {
      fill(lerpColor( color((brightness(TMPcolor) > 128) ? (0) : (255)) , light, 0.2f));
    } 
    else {
      fill(lerpColor( color((brightness(TMPcolor) > 128) ? (0) : (255)) , shade, 0.2f));
    }
   }
   
   textAlign(CENTER, CENTER);
   textFont(fontTitle, fontsize);
   textLeading(fontsize);
   fill(Color);
   text(texto, x+c/2, y-b/2);
    //textAlign(LEFT);  
    rectMode(CORNER);
    textFont(f,20);
    popStyle();
}

}


class Credito{
  Button botao;
  Button processing;
  boolean showCred;
  boolean mais;

  Credito(){
    //int xp, int yp, int width, int height,String texto, boolean show
 
    botao = new Button(555, 625, 60,30, "Cr\u00e9ditos", true);
    processing  =new Button(180 ,235, 90, 15, "Processing", false);
    processing.Color= color(4, 51, 255);
    processing.fontsize = 14;
    
    mais = false;
    showCred = false;
  }

  public void display(){     
        
    rectMode(CENTER);   
    if( showCred == true){
      //fill(15, 50);
      //rect(0, 0, width, height);
           botao.texto =  "Ocultar\nCr\u00e9ditos";   
      textAlign(LEFT);
      textFont(fontTitle ,12);    
      fill(240, 240);  
      textLeading(12);
      noStroke();
      
      
      if(mais){
        //rect(width-30, height/2, 400, 400);
         rect(width/2, height/2-30, width/2+250, height/2+130);
        fill(0);
        text(       "\t\t                                                           CR\u00c9DITOS" +

    "\n\nDesenvolvimento: Gustavo Estevam Gimenes (Aluno do 2\u00ba ano do Curso de\n" +
    "                             Engenharia de Materiais - N\u00facleo Comum, Escola Polit\u00e9cnica\n"+
    "                             da Universidade de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)"                         + 
    "\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia\n" + 
    "                   Metal\u00fargica e de Materiais, Escola Polit\u00e9cnica da Universidade \n"+ 
    "                   de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)" +
    "\n\nTexto: Ivette Frida Cymbaum Oppenheim e Gustavo Estevam Gimenes\n"+
    "\n\nCriado em:                                           \u00daltima atualiza\u00e7\u00e3o: 12/julho/2011 " + 
    //           " Processing" + 
  "\n\n\nO meio:    'Processing' \u00e9 uma linguagem de programa\u00e7\u00e3o e ambiente de desen-" +  
    "\n              volvimento com foco principal nas artes visuais, aproveitando-se da" +
    "\n              plataforma Java e de uma comunidade virtual intensamente atuante por" + 
    "\n              meio do compartilhamento de c\u00f3digos e bibliotecas atrav\u00e9s da Internet." + 
    "\n\n              Surgiu como iniciativa de Casey Reas e Ben Fry, pesquisadores do" +
    "\n              Instituto de Tecnologia de Massachussets (MIT) dos E.U.A, sendo, des-" +
    "\n              de sua cria\u00e7\u00e3o em 2001, disponibilizado gratuitamente como software" +
    "\n              livre, acess\u00edvel a qualquer interessado a partir do download  no site" + 
    "\n              'processing.org', onde podem ser encontradas informa\u00e7\u00f5es adicionais" +
    "\n              sobre 'Processing'." +    
    "\n\n\nApoio: A anima\u00e7\u00e3o 'Magnetismo dos Materiais' foi desenvolvida no contexto do"+
    "\n           projeto 'Anima\u00e7\u00f5es para disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia"+
    "\n           dos Materiais', integrante do 'Programa Ensinar com Pesquisa' da Pr\u00f3-Reitoria"+
    "\n           de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo, \u00e0 qual expressamos nossos"+
    "\n           agradecimentos pela concess\u00e3o da bolsa de Inicia\u00e7\u00e3o Cient\u00edfica"+
    "\n           (Projeto 1887 - ano 2010)."     /*+      "\n\n                                                       REFER\u00caNCIAS"+
    "\n\n Charles Kittel, 'Introduction to Solid State Physics', 8\u00aa Edi\u00e7\u00e3o, Editora "+
    " John\nWiley & Sons, Inc., 2005. (ISBN 0-471-41526-X)"+
    "\n\n Walter Lewin - Lecture 21, ocw.mit.edu/courses/physics/8-02-electricityand-"+
    "\nmagnetism-spring-2002/, 24k, 2010-11-22"+       
     "\n\nMathias Getzlaff, 'Fundamentals of Magnetism', Editora Springer, 2008\n(ISBN 978-3-540-31150-8)"+
    
    "\n\n William D. Callister, Jr., 'Materials science and engineering : an introduction',\n"+
    "7\u00aa Edi\u00e7\u00e3o, editora John Wiley & Sons, 2007 (ISBN: 0-471-73696-1)."*/
          ,width/2 - 220, height/2 - 240);
      }

      else{
          rect(width/2, height/2-10, width/2+250, height/2+170);
        fill(0);
        text(  "\t\t                                                           CR\u00c9DITOS" +

    "\n\nDesenvolvimento: Gustavo Estevam Gimenes (Aluno do 2\u00ba ano do Curso de\n" +
    "                             Engenharia de Materiais - N\u00facleo Comum, Escola Polit\u00e9cnica\n"+
    "                             da Universidade de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)"                         + 
    "\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia\n" + 
    "                   Metal\u00fargica e de Materiais, Escola Polit\u00e9cnica da Universidade \n"+ 
    "                   de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)" +
    "\n\nTexto: Ivette Frida Cymbaum Oppenheim e Gustavo Estevam Gimenes\n"+
    "\n\nCriado em:                                           \u00daltima atualiza\u00e7\u00e3o: 12/julho/2011 " + 
    "\n\n\nApoio: A anima\u00e7\u00e3o 'Magnetismo dos Materiais' foi desenvolvida no contexto do"+
    "\n           projeto 'Anima\u00e7\u00f5es para disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia"+
    "\n           dos Materiais', integrante do 'Programa Ensinar com Pesquisa' da Pr\u00f3-Reitoria"+
    "\n           de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo, \u00e0 qual expressamos nossos"+
    "\n           agradecimentos pela concess\u00e3o da bolsa de Inicia\u00e7\u00e3o Cient\u00edfica"+
    "\n           (Projeto 1887 - ano 2010)."     +
    "\n\n                                                       REFER\u00caNCIAS"+
    "\n\n Charles Kittel, 'Introduction to Solid State Physics', 8\u00aa Edi\u00e7\u00e3o, Editora "+
    " John\nWiley & Sons, Inc., 2005. (ISBN 0-471-41526-X)"+
    "\n\n Walter Lewin - Lecture 21, ocw.mit.edu/courses/physics/8-02-electricityand-"+
    "\nmagnetism-spring-2002/, 24k, 2010-11-22"+       
     "\n\nMathias Getzlaff, 'Fundamentals of Magnetism', Editora Springer, 2008\n(ISBN 978-3-540-31150-8)"+
    
    "\n\n William D. Callister, Jr., 'Materials science and engineering : an introduction',\n"+
    "7\u00aa Edi\u00e7\u00e3o, editora John Wiley & Sons, 2007 (ISBN: 0-471-73696-1)."+
    "\n\n'Introdu\u00e7\u00e3o \u00e0 Ci\u00eancia dos Materiais para Engenharia' (EPUSP - PMT2100),\n"+
    "Slides da aula te\u00f3rica 13, ano 2009."
         ,width/2 - 220, height/2 - 240);
      }     
      
      processing.display();
      processing.update();
   }else     botao.texto =  "Cr\u00e9ditos";
    textFont(fontButton, 16);
    botao.display();
    botao.update();
    
  if(processing.over) processing.Color = color(100,100,255);
  else if((mais)) processing.Color  = color(100);
  else processing.Color = color(50, 50, 255);
}
  
public void mousePressed(){
if((processing.press()==true)&&(mais==true)){
    mais = false;
  }
  else if((processing.press() == true)&&(mais==false)){
    mais = true;   
  } 
   botao.update();
   
  if((botao.press()==true)&&(showCred==true)){
    showCred = false;
  }
  else if((botao.press() == true)&&(showCred==false)){
    showCred = true;
  } 
 }
 
 public void mouseReleased(){
   botao.release();
 }
 
}
class Scrollbar {
  float swidth, sheight;    // width and height of bar
  float xpos, ypos;         // x and y position of bar
  float spos, newspos;    // x position of slider
  // float sposMin, sposMax;   // max and min values of slider
  float loose;              // how loose/heavy
  boolean over;           // is the mouse over the slider?
  boolean locked;
  float ratio;
  float c = 0.65f, b = 2.5f;
  float sliderWidth, sliderHeight;


  Scrollbar (float xp, float yp, float sw, float sh, float l, float sWidth, float sHeight) {
    swidth = sw;
    sheight = sh;
    float widthtoheight = sw - sh;
    ratio = (float)sw / (float)widthtoheight;
    xpos = xp;
    ypos = yp-sheight/2;
    spos = xpos;
    newspos = spos;
    sliderWidth = sWidth;
    sliderHeight = sHeight; 
   if(swidth > sheight){   
       spos = xpos-swidth/2+50;
    }else spos = ypos-sheight/2;
    // sposMin = xpos-swidth/2.1;
    // sposMax = xpos + swidth/1.9;
    loose = l;
  }

  Scrollbar (float xp, float yp, float sw, float sh, float l) {      
    swidth = sw;
    sheight = sh;
    float widthtoheight = sw - sh;
    ratio = (float)sw / (float)widthtoheight;
    xpos = xp;
    ypos = yp-sheight/2;
    newspos = spos;

    // sposMin = xpos-swidth/2.1;
    // sposMax = xpos + swidth/1.9;
    loose = l;
  }

  public void update() {
    if(over()) {
      over = true;
    } 
    else {
      over = false;
    }

    if(mousePressed && over) {
      locked = true;
    }

    if(!mousePressed) {
      locked = false;
    }

    if(locked) {
      if(swidth>=sheight) {
        newspos=mouseX;      
        if (newspos-sliderWidth/2<xpos-swidth/2) newspos = xpos-swidth/2+sliderWidth/2;
        if (newspos+sliderWidth/2>xpos+swidth/2) newspos = xpos+swidth/2-sliderWidth/2;
      } 
      else {
        newspos = mouseY;
        if (newspos-sliderHeight/2<ypos-sheight/2) newspos = ypos-sheight/2+sliderHeight/2;
        if (newspos+sliderHeight/2>ypos+sheight/2) newspos = ypos+sheight/2-sliderHeight/2;
      }
    }

    spos = (newspos);
  }

  public int constrain(int val, int minv, int maxv) {
    return min(max(val, minv), maxv);
  }

  public boolean over() {
    if(mouseX > xpos-swidth/2 && mouseX < xpos+swidth/2 &&
      mouseY > ypos-sheight/2 && mouseY < ypos+sheight/2) {
      return true;
    } 
    else {
      return false;
    }
  }

  public void display() {
    pushStyle();
    beginShape(QUADS);
    noStroke();

    fill(0xffAAAAAA);
    vertex(xpos - (swidth + b)/2, ypos - (sheight + b)/2);
    vertex(xpos - (swidth)/2, ypos - (sheight)/2);
    vertex(xpos - (swidth)/2, ypos + (sheight)/2);
    vertex(xpos - (swidth + b)/2, ypos + (sheight + b)/2);

    vertex(xpos - (swidth + b)/2, ypos + (sheight + b)/2);
    vertex(xpos - (swidth)/2, ypos + (sheight)/2);
    vertex(xpos + (swidth)/2, ypos + (sheight)/2);
    vertex(xpos + (swidth + b)/2, ypos + (sheight + b)/2);   


    fill(0xff000001);
    vertex(xpos - (swidth + b)/2, ypos - (sheight + b)/2);
    vertex(xpos - (swidth)/2, ypos - (sheight)/2);
    vertex(xpos + (swidth)/2, ypos - (sheight)/2);
    vertex(xpos + (swidth + b)/2, ypos - (sheight + b)/2);

    vertex(xpos + (swidth + b)/2, ypos - (sheight + b)/2);
    vertex(xpos + (swidth)/2, ypos - (sheight)/2);
    vertex(xpos + (swidth)/2, ypos + (sheight)/2);
    vertex(xpos + (swidth + b)/2, ypos + (sheight + b)/2);
    endShape();


    fill(150,5);     

    rectMode(CENTER);
    rect(xpos, ypos, swidth, sheight);

    if(over || locked) {
      fill(87, 87, 87);
    }
    else {
      fill(122, 122, 122);
    }

    if(swidth>sheight) {
      rect(spos, ypos, sliderWidth, sliderHeight);
      beginShape(QUADS);
      noStroke();
      fill(0xff000001);
      vertex(spos - (sliderWidth + b)/2, ypos - (sliderHeight + b)/2);
      vertex(spos - (sliderWidth)/2, ypos - (sliderHeight)/2);
      vertex(spos - (sliderWidth)/2, ypos + (sliderHeight)/2);
      vertex(spos - (sliderWidth + b)/2, ypos + (sliderHeight + b)/2);

      vertex(spos - (sliderWidth + b)/2, ypos + (sliderHeight + b)/2);
      vertex(spos - (sliderWidth)/2, ypos + (sliderHeight)/2);
      vertex(spos + (sliderWidth)/2, ypos + (sliderHeight)/2);
      vertex(spos + (sliderWidth + b)/2, ypos + (sliderHeight + b)/2);   

      fill(0xffAAAAAA);
      vertex(spos - (sliderWidth + b)/2, ypos - (sliderHeight + b)/2);
      vertex(spos - (sliderWidth)/2, ypos - (sliderHeight)/2);
      vertex(spos + (sliderWidth)/2, ypos - (sliderHeight)/2);
      vertex(spos + (sliderWidth + b)/2, ypos - (sliderHeight + b)/2);

      vertex(spos + (sliderWidth + b)/2, ypos - (sliderHeight + b)/2);
      vertex(spos + (sliderWidth)/2, ypos - (sliderHeight)/2);
      vertex(spos + (sliderWidth)/2, ypos + (sliderHeight)/2);
      vertex(spos + (sliderWidth + b)/2, ypos + (sliderHeight + b)/2);
      endShape();
    }
    else {
      rect(xpos, spos, sliderWidth, sliderHeight);
      beginShape(QUADS);
      noStroke();
      fill(0xff000001);
      vertex(xpos - (sliderWidth + b)/2, spos - (sliderHeight + b)/2);
      vertex(xpos - (sliderWidth)/2, spos - (sliderHeight)/2);
      vertex(xpos - (sliderWidth)/2, spos + (sliderHeight)/2);
      vertex(xpos - (sliderWidth + b)/2, spos + (sliderHeight + b)/2);

      vertex(xpos - (sliderWidth + b)/2, spos + (sliderHeight + b)/2);
      vertex(xpos - (sliderWidth)/2, spos + (sliderHeight)/2);
      vertex(xpos + (sliderWidth)/2, spos + (sliderHeight)/2);
      vertex(xpos + (sliderWidth + b)/2, spos + (sliderHeight + b)/2);   

      fill(0xffAAAAAA);
      vertex(xpos - (sliderWidth + b)/2, spos - (sliderHeight + b)/2);
      vertex(xpos - (sliderWidth)/2, spos - (sliderHeight)/2);
      vertex(xpos + (sliderWidth)/2, spos - (sliderHeight)/2);
      vertex(xpos + (sliderWidth + b)/2, spos - (sliderHeight + b)/2);

      vertex(xpos + (sliderWidth + b)/2, spos - (sliderHeight + b)/2);
      vertex(xpos + (sliderWidth)/2, spos - (sliderHeight)/2);
      vertex(xpos + (sliderWidth)/2, spos + (sliderHeight)/2);
      vertex(xpos + (sliderWidth + b)/2, spos + (sliderHeight + b)/2);
      endShape();
    }
    fill(0);
    popStyle();
  }

  public float getPos() {         //now working 
    // Convert spos to be values between                      
    // 0 and the total width of the scrollbar
    if(swidth>sheight) return (spos-xpos+swidth/2-sliderWidth/2)/(swidth-sliderWidth);   
    else    return (spos-ypos+sheight/2-sliderHeight/2)/(sheight-sliderHeight);
  }
}

//based on Bresenham's algorithm from wikipedia
//http://en.wikipedia.org/wiki/Bresenham's_line_algorithm

public void patternLine(int xStart, int yStart, int xEnd, int yEnd, int linePattern, int lineScale) {
  int temp, yStep, x, y;
  int pattern = linePattern;
  int carry;
  int count = lineScale;

  boolean steep = (abs(yEnd - yStart) > abs(xEnd - xStart));
  if (steep == true) {
    temp = xStart;
    xStart = yStart;
    yStart = temp;
    temp = xEnd;
    xEnd = yEnd;
    yEnd = temp;
  }    
  if (xStart > xEnd) {
    temp = xStart;
    xStart = xEnd;
    xEnd = temp;
    temp = yStart;
    yStart = yEnd;
    yEnd = temp;
  }
  int deltaX = xEnd - xStart;
  int deltaY = abs(yEnd - yStart);
  int error = - (deltaX + 1) / 2;

  y = yStart;
  if (yStart < yEnd) {
    yStep = 1;
  } 
  else {
    yStep = -1;
  }
  for (x = xStart; x <= xEnd; x++) {
    if ((pattern & 1) == 1) {
      if (steep == true) {
        point(y, x);
      } 
      else {
        point(x, y);
      }
      carry = 0x8000;
    } 
    else {
      carry = 0;
    }  
    count--;
    if (count <= 0) {
      pattern = (pattern >> 1) + carry;
      count = lineScale;
    }

    error += deltaY;
    if (error >= 0) {
      y += yStep;
      error -= deltaX;
    }
  }
}

//By putting the texts in different PGraphics, I hope to justify and scroll themtex
class textBox {
  float xpos, ypos; // position of the box per se (corner)
  float boxwidth, boxheight;
  PGraphics textshow; //scroll will work as a buffer
  String texto; 
  PFont font;
  int fontSize;
  String auxtext;
  Scrollbar yScroll;  
  float sliderWidth, sliderHeight;
  
  float c = 0.65f, b = 2.5f;
  
  float  xOffset=2;
  float  yOffset=0; //due to lack of a better name, gonna call this offset. How much eacxh textBlock is displaced in the textShow
  //initially, just using vertical displacement (we got wrap)
  //in reality, position of the text inside the textbox
  int countLines; //initially ,a direct input of the number of lines; used for changing the size of the bar 
  
  textBox(float _x, float _y, float _width,float _height, String _texto, PFont _font, int _fontsize, float _sWidth, float _sHeight) {
    xpos = _x;
    ypos = _y;
    boxwidth = _width;
    boxheight = _height;
    texto =_texto;
    font = _font;
    fontSize = _fontsize;
    sliderWidth = _sWidth;
    sliderHeight = _sHeight;
    //Scrollbar (float xp, float yp, float sw, float sh, float l, float sWidth, float sHeight)
    yScroll = new Scrollbar (xpos+boxwidth/2-6,ypos+_height/2, 12,boxheight-0.1f, 3,sliderWidth, sliderHeight);
   
    textshow = createGraphics(PApplet.parseInt(boxwidth), PApplet.parseInt(boxheight), JAVA2D);
   // yScroll. 
    textshow.smooth();
    }

  //xScroll = new Scrollbar (x+_width, y+_height/2, height,10, 3);
  public void display() {  
    pushMatrix();
    pushStyle();
    textshow.beginDraw();
    textshow.background(0,0);
    textshow.fill(0);
    
    textshow.textAlign(LEFT);
    textshow.textFont(font, fontSize);
    textshow.textLeading(fontSize+1);
    textshow.text(texto,  xOffset,yOffset, boxwidth-15, 10000); 
    textshow.endDraw();
 
    imageMode(CENTER);
    image(textshow, xpos, ypos, boxwidth, boxheight);
    //drawing the border of the textfield
    beginShape(QUADS);
    noStroke();
    fill(0xffAAAAAA);
    vertex(xpos - (boxwidth + b)/2, ypos - (boxheight + b)/2);
    vertex(xpos - (boxwidth)/2, ypos - (boxheight)/2);
    vertex(xpos - (boxwidth)/2, ypos + (boxheight)/2);
    vertex(xpos - (boxwidth + b)/2, ypos + (boxheight + b)/2);

    vertex(xpos - (boxwidth + b)/2, ypos + (boxheight + b)/2);
    vertex(xpos - (boxwidth)/2, ypos + (boxheight)/2);
    vertex(xpos + (boxwidth)/2, ypos + (boxheight)/2);
    vertex(xpos + (boxwidth + b)/2, ypos + (boxheight + b)/2);   


    fill(0xff000001);
    vertex(xpos - (boxwidth + b)/2, ypos - (boxheight + b)/2);
    vertex(xpos - (boxwidth)/2, ypos - (boxheight)/2);
    vertex(xpos + (boxwidth)/2, ypos - (boxheight)/2);
    vertex(xpos + (boxwidth + b)/2, ypos - (boxheight + b)/2);

    vertex(xpos + (boxwidth + b)/2, ypos - (boxheight + b)/2);
    vertex(xpos + (boxwidth)/2, ypos - (boxheight)/2);
    vertex(xpos + (boxwidth)/2, ypos + (boxheight)/2);
    vertex(xpos + (boxwidth + b)/2, ypos + (boxheight + b)/2);
    endShape();
    
    noFill();
    stroke(0);
   // rect(xpos,ypos, boxwidth, boxheight);
    yOffset =-countLines*(yScroll.getPos()); //gonna have to limit this
    yScroll.display();
    yScroll.update();
    popMatrix();
    popStyle();
  }
}


String[][] polyExplain = new String[8][2];
String[][] polyScreen = new String[10][2];


public void setText() {
  polyScreen[0][0] = "<<Voltar";
  polyScreen[1][0]="Magnetismo dos Materiais";
  polyScreen[2][0] = "Diamagn\u00e9ticos";
  polyScreen[3][0] = "Paramagn\u00e9ticos";
  polyScreen[4][0] = "Ferromagn\u00e9ticos";
  polyScreen[5][0] = "Campo Magn\u00e9tico Externo\nAplicado";
  polyScreen[6][0] ="Temperatura: " ;
  polyScreen[7][0] = "Baixa";
  polyScreen[8][0] ="M\u00e9dia";
  polyScreen[9][0] ="Alta";


  polyExplain[0][0] = "Magnetiza\u00e7\u00e3o muito fraca,"  +
    " de mesma dire\u00e7\u00e3o e sentido "+
    "oposto \u00e0 do campo magn\u00e9tico "+
    "externo, existente apenas na "+
    "presen\u00e7a de um campo magn\u00e9tico externo.";
  polyExplain[1][0] ="Magnetiza\u00e7\u00e3o fraca,"  +
    " de mesma dire\u00e7\u00e3o e sentido "  +
    "\u00e0 do campo magn\u00e9tico externo, "+
    "decorrente da presen\u00e7a de "+
    "momentos de dipolo magn\u00e9tico at\u00f4mico "+
    "permanente, mas nula na "+
    "aus\u00eancia de campo externo "+    
    "devido \u00e0 vibra\u00e7\u00e3o t\u00e9rmica."; 
  polyExplain[2][0] = "Magnetiza\u00e7\u00e3o forte, "+
    " resultante da presen\u00e7a "+
    "de momentos de dipolo magn\u00e9tico at\u00f4mico "+
    "permanente, alinhados com seus \u00e1tomos vizinhos (vide figura ao lado)"+
    " e organizados numa escala maior em Dom\u00ednios "+
    "Magn\u00e9ticos, onde todos "+ 
    "os \u00e1tomos tem seus momentos "+
    "magn\u00e9ticos alinhados.";
  polyExplain[3][0] = "Temperatura de Curie.\n"+
    "Para temperaturas maiores,\n"+
    "o material ferromagn\u00e9tico\n"+
    "passa a ter comportamento\nparamagn\u00e9tico";
  polyExplain[4][0] = 
    "Apresentam magnetiza\u00e7\u00e3o muito fraca, de "+
    "mesma dire\u00e7\u00e3o e sentido oposto \u00e0 do campo "+
    "magn\u00e9tico externo. Essa magnetiza\u00e7\u00e3o deve-se "+
    "exclusivamente ao momento angular orbital "+
    "eletr\u00f4nico induzido, existente apenas na "+
    "presen\u00e7a de um campo magn\u00e9tico externo.\n"+
    "    Materiais diamagn\u00e9ticos possuem "+
    "permeabilidade magn\u00e9tica relativa menor do "+
    "que 1 e susceptibilidade magn\u00e9tica negativa, "+
    "sendo o campo magn\u00e9tico em seu interior um "+
    "pouco menor do que o campo magn\u00e9tico externo. \n"+
    "    Materiais diamagn\u00e9ticos s\u00e3o repelidos por im\u00e3s, "+
    "ou seja, quando sujeitos a campos magn\u00e9ticos "+
    "externos n\u00e3o uniformes s\u00e3o for\u00e7ados a se "+
    "afastar das regi\u00f5es de campos mais intensos. "+
    "Propriedades diamagn\u00e9ticas s\u00e3o essencialmente "+
    "independentes da temperatura do material. ";
  polyExplain[5][0] =    "Nesses materiais, os \u00e1tomos ou as mol\u00e9culas "+
    "constituintes possuem momento de dipolo magn\u00e9tico "+
    "permanente (tais quais pequenos im\u00e3s), resultante do spin de el\u00e9trons "+
    "desemparelhados.\n    Na aus\u00eancia de campos magn\u00e9ticos externos, as "+
    "dire\u00e7\u00f5es dos momentos de dipolo "+
    "permanente s\u00e3o aleat\u00f3rias e, portanto, o "+
    "campo magn\u00e9tico produzido pelo material \u00e9 "+
    "nulo. Im\u00e3s permanentes n\u00e3o podem ser "+
    "fabricados com materiais paramagn\u00e9ticos. "+
    "\n    Quando um campo magn\u00e9tico constante \u00e9 "+
    "aplicado sobre um material paramagn\u00e9tico, os "+
    "momentos de dipolo dos \u00e1tomos ou "+
    "mol\u00e9culas tendem a se alinhar com o campo "+
    "externo. O grau de alinhamento depende da "+
    "intensidade do campo e da temperatura do "+
    "material. Quanto mais baixa a temperatura, "+
    "menor a energia t\u00e9rmica, e menos intenso \u00e9 o "+
    "campo necess\u00e1rio para um dado grau de "+
    "alinhamento."+
    "\n    Materiais paramagn\u00e9ticos possuem "+
    "permeabilidade magn\u00e9tica relativa maior do "+
    "que 1 e susceptibilidade magn\u00e9tica positiva, "+
    "sendo o campo magn\u00e9tico em seu interior um "+
    "pouco maior que o campo magn\u00e9tico externo."+
    "\n    Esses materiais s\u00e3o atra\u00eddos por im\u00e3s, ou seja, "+
    "s\u00e3o for\u00e7ados a se aproximar das "+
    "regi\u00f5es de campo mais intenso quando sujeitos a campos magn\u00e9ticos externos n\u00e3o uniformes."+
    " Quando o campo magn\u00e9tico externo \u00e9 retirado, "+
    "as dire\u00e7\u00f5es dos momentos de dipolo magn\u00e9tico voltam a "+
    "ser aleat\u00f3rias.";
  polyExplain[6][0] = "Nesses materiais, os \u00e1tomos ou as mol\u00e9culas "+
    "constituintes possuem momento de dipolo magn\u00e9tico "+
    "permanente, resultante do spin de el\u00e9trons "+
    "desemparelhados. Esses \u00e1tomos ou mol\u00e9culas "+
    "podem ser pensados como sendo pequenos "+
    "im\u00e3s.\n"+
    "    Antes da exposi\u00e7\u00e3o de corpos fabricados com "+
    "materiais ferromagn\u00e9ticos a campos "+
    "magn\u00e9ticos externos, eles s\u00e3o formados por "+
    "uma esp\u00e9cie de rede magn\u00e9tica, cujas c\u00e9lulas, "+
    "denominadas DOM\u00cdNIOS MAGN\u00c9TICOS, possuem "+
    "tamanhos, formas e dire\u00e7\u00f5es de suas "+
    "respectivas magnetiza\u00e7\u00f5es tais que o campo "+
    "magn\u00e9tico produzido pelo corpo seja nulo. "+
    "Em cada dom\u00ednio magn\u00e9tico, os momentos "+
    "de dipolo magn\u00e9tico, at\u00f4micos ou moleculares, est\u00e3o "+
    "perfeitamente alinhados uns com os outros, ou "+
    "seja, o material em tais regi\u00f5es apresenta sua Magnetiza\u00e7\u00e3o de "+
    "Satura\u00e7\u00e3o.\n"+
    "    O tamanho dos dom\u00ednios depende das "+
    "dimens\u00f5es do corpo, de sua geometria, do "+
    "material ferromagn\u00e9tico de que \u00e9 fabricado, "+
    "dentre outros. Dom\u00ednios podem atingir "+
    "tamanhos sub-milim\u00e9tricos e serem compostos "+
    "por um n\u00famero muito grande (10 elevado \u00e0 17 a 10 elevado \u00e0 21) de "+
    "part\u00edculas (\u00e1tomos ou mol\u00e9culas). "+
    "A for\u00e7a motriz para a forma\u00e7\u00e3o das estruturas "+
    "de dom\u00ednios magn\u00e9ticos (distribui\u00e7\u00e3o de "+
    "tamanhos e formas dos dom\u00ednios) resulta da "+
    "tend\u00eancia dos materiais a minimizarem sua "+
    "energia livre; uma energia magn\u00e9tica alta \u00e9 associada a um material "+
    "magneticamente saturado (formado por um "+
    "\u00fanico dom\u00ednio), "+
    "enquanto a forma\u00e7\u00e3o de dom\u00ednios geralmente "+
    "leva \u00e0 diminui\u00e7\u00e3o da energia magn\u00e9tica.\n"+
    "    Sob a a\u00e7\u00e3o de um campo magn\u00e9tico externo, "+
    "as magnetiza\u00e7\u00f5es dos dom\u00ednios tendem a se "+
    "alinhar com a dire\u00e7\u00e3o do campo externo. O "+
    "grau de alinhamento depende, em primeira "+
    "ordem, da intensidade do campo e da "+
    "temperatura do material. Quanto mais baixa a "+
    "temperatura, menor a energia t\u00e9rmica, "+
    "e menos intenso \u00e9 o campo necess\u00e1rio para um "+
    "dado grau de alinhamento. Quanto maior a temperatura, mais acentuadas as vibra\u00e7\u00f5es t\u00e9rmicas, e mais enfraquecidas ficam as for\u00e7as de "+
    "acoplamento entre os momentos de dipolo " +
    "magn\u00e9tico at\u00f4mico adjacentes, levando a uma redu\u00e7\u00e3o da magnitude da magnetiza\u00e7\u00e3o de satura\u00e7\u00e3o do material."+
    " Para uma dada temperatura, denominada Temperatura de Curie (Tc), o valor da magnetiza\u00e7\u00e3o de satura\u00e7\u00e3o "+
    "passa a ser zero, e o material adquire um comportamento paramagn\u00e9tico."+
    "\n"+
    "    Materiais ferromagn\u00e9ticos possuem "+
    "susceptibilidades magn\u00e9ticas grandes, sendo a intensidade do "+
    "campo em seu interior milhares de vezes maior do "+
    "que a do campo magn\u00e9tico externo. "+
    "Esses materiais s\u00e3o atra\u00eddos por im\u00e3s, ou seja, "+
    "quando sujeitos a campos magn\u00e9ticos externos "+
    "n\u00e3o uniformes s\u00e3o for\u00e7ados a se aproximar das "+
    "regi\u00f5es de campos mais intensos.\n"+
    "    Quando o campo magn\u00e9tico \u00e9 retirado de um material ferromagn\u00e9tico, alguns "+
    "dos dom\u00ednios magn\u00e9ticos podem manter a magnetiza\u00e7\u00e3o na "+
    "dire\u00e7\u00e3o previamente definida pelo campo "+
    "externo, enquanto outros alteram a dire\u00e7\u00e3o de "+
    "suas magnetiza\u00e7\u00f5es devido \u00e0 energia t\u00e9rmica. "+
    "A exist\u00eancia de magnetiza\u00e7\u00e3o remanente "+
    "implica que im\u00e3s permanentes podem ser "+
    "fabricados com materiais ferromagn\u00e9ticos. "+
    "A magnetiza\u00e7\u00e3o remanente de um "+
    "ferromagneto pode ser removida fornecendo ao "+
    "material energia t\u00e9rmica e/ou mec\u00e2nica. ";


  polyExplain[7][0] = "O magnetismo \u00e9 um fen\u00f4meno de origem qu\u00e2ntica. Tr\u00eas fatores s\u00e3o determinantes para\n"+
    "a defini\u00e7\u00e3o do momento magn\u00e9tico de um \u00e1tomo livre: o SPIN dos el\u00e9trons, o MOMENTO\n"+
    "ANGULAR ORBITAL dos el\u00e9trons em torno do n\u00facleo e a ALTERA\u00c7\u00c3O do momento\n"+
    "angular orbital INDUZIDA pela aplica\u00e7\u00e3o de um campo magn\u00e9tico externo. Para um\n"+
    "material, o momento de dipolo magn\u00e9tico por unidade de volume \u00e9 definido como sendo sua\n"+
    "MAGNETIZA\u00c7\u00c3O, grandeza influenciada tamb\u00e9m pela intera\u00e7\u00e3o entre os \u00e1tomos da amostra.\n" +
    "Controle o CAMPO EXTERNO aplicado arrastando o mouse no espa\u00e7o indicado, controle\n"+ 
    "a TEMPERATURA por meio do slider e observe o comportamento de cada material. Ao\n"+
    "clicar sobre um material, uma EXPLICA\u00c7\u00c3O MAIS DETALHADA ser\u00e1 exibida.";
}

public void variable(String[] var, String[] explicacao, float x, float y, int f) { 
  //dado uma f\u00f3rmula guardada num array var e a explica\u00e7\u00e3o bonitinha
  //guardada no explicacao, vai escrever na tela a f\u00f3rmula e, quando o mouse estiver sobre algum termo, sua defini\u00e7\u00e3o ser\u00e1 exibida 
  //os dois vetores devem ter o mesmo tamanho. f \u00e9 o tamanho da fonte. vai desenhar um vetor em cima da letra caso ela seja precedida por *; faz subscrito de seguida por _
  //Sintaxe: X* => X vetor
  // X^a => X^a, superscrito
  //X_a = X a subscrito
  //X  + => +X 

  pushStyle();
  textSize(f);
  textLeading(f);
  textAlign(LEFT);  
  fill(0);

  for(int i = 0; i <var.length; i++) {
    fill(0);  
    stroke(0);
    if((mouseX>(x+1.5f*i*f))&&(mouseX<(x+(1.5f*i+1)*f))&&(mouseY>(y-f))&&(mouseY<(y))) {
      text(explicacao[i], x+i*f, y+f);
    }

    if(var[i].length()>1) {


      if(var[i].charAt(1) ==  '*') {
        arrowline(x+(i+0.1f)*f, y-f, x+(i+0.8f)*f, y-f, g);
      }

      if(var[i].charAt(1) ==  '_') {
        textSize(f/1.5f);
        text(var[i].charAt(2), x+(i+0.5f)*f,y+f/4);
        textSize(f);
      }

      if(var[i].charAt(1) ==  '^') {
        textSize(f/1.5f);
        text(var[i].charAt(2),x+(i+0.5f)*f,y-f/2);
        textSize(f);
      }
      if(var[i].length()>3) {
        if((var[i].charAt(3) ==  '+')) {
          text("+"+var[i].charAt(0), x+i*f-f/1.8f, y);
        }
        if((var[i].charAt(3) ==  '-')) {
          text("-"+var[i].charAt(0), x+i*f-f/1.8f, y);
        }
      }
      else text(var[i].charAt(0), x+i*f, y);
    }
    else   text(var[i].charAt(0), x+i*f, y);
    //detectando mouse
  }    
  popStyle();
}



public void variable(String var, String explicacao, float x, float y, int f, float boxPosx, float boxPosy, float boxWidth, float boxHeight) { 
  //dado uma f\u00f3rmula guardada num array var e a explica\u00e7\u00e3o bonitinha
  //guardada no explicacao, vai escrever na tela a f\u00f3rmula e, quando o mouse estiver sobre algum termo, sua defini\u00e7\u00e3o ser\u00e1 exibida 
  //os dois vetores devem ter o mesmo tamanho. f \u00e9 o tamanho da fonte. vai desenhar um vetor em cima da letra caso ela seja precedida por *; faz subscrito de seguida por _
  pushStyle();
  textSize(f);
  textLeading(f);
  textAlign(LEFT);  
  fill(0);  
  stroke(0);

  if((mouseX>(x-f))&&(mouseX<(x+f))&&(mouseY>(y-f))&&(mouseY<(y+f))) {
    explicacao(boxPosx, boxPosy, explicacao, boxWidth, boxHeight, f);
     }

  if(var.length()>1) {
    if(var.charAt(1) ==  '*') {
      arrowline(x+(0.1f)*f, y-f, x+(0.8f)*f, y-f, g);
    }
    if(var.charAt(1) ==  '_') {
      textSize(f/1.5f);
      text(var.charAt(2), x+0.6f*f,y+f/4);
      textSize(f);
    }

    if(var.charAt(1) ==  '^') {
      textSize(f/1.5f);
      text(var.charAt(2),x+(0.5f)*f,y-f/2);
      textSize(f);
    }
    
    if(var.length()>3) {
      if((var.charAt(3) ==  '+')) {
        text("+"+var.charAt(0), x-f/1.8f, y);
      }
      if((var.charAt(3) ==  '-')) {
        text("-"+var.charAt(0), x-f/1.8f, y);
      }
      if(var.charAt(1) ==  '^') {
        text(var.charAt(0), x, y);
      textSize(f/1.5f);
      text(var.charAt(2),x+(0.5f)*f,y-f/2);
      text(var.charAt(3),x+(0.5f)*f,y-f/2);
      textSize(f);
    }  
  }
    
    
    else text(var.charAt(0), x, y);
  }
  else   text(var.charAt(0), x, y);


  // text(var.charAt(0), x, y);
  //detectando mouse 
  popStyle();
}

public void explicacao(float xpos, float ypos, String explain, float vwidth, float vheight, int f){ //will create a pop-up to explain some variable; xpos and ypos are the position of the variable; 
    toggleText = true;
    pushStyle();
    //first, this smooth transition, using millis 
    stroke(0);
    fill(150);
    rectMode(CORNER);
    noStroke();
   fill(0,15);
   if(vwidth!=0)   rect(365,280,220,180);
    textSize(12);
    textLeading(12);
    textAlign(LEFT);
    
    fill(0);
    text(explain, xpos+f/6, ypos+f);
    popStyle();
}

public void vector(float x, float y, float a){
      //controling and showingthe external field 
       rectMode(CENTER);
       stroke(0,12);  
       noFill(); 
       // fill(200,10);
        rect(x, y, a, a);
        
      if((mouseX>(x-a/2))&&(mouseX<(x+a/2))&&(mouseY>(y-a/2))&&(mouseY<(y+a/2))) {
        stroke(0,12);    
        fill(200,10);
        rect(x, y, a, a);
       if(mousePressed) {
         mod = dist(mouseX, mouseY, x, y)*a*0.2f/100;  
       if(mod>=a*a*0.2f/100/2) mod=a*a*0.2f/100/2;
        //println(mod);
        if(mod*7>5) angle = atan2(mouseY-(y), mouseX-(x));
       
          }
      }  
    
    //variable("H*", "Campo\nExterno\nAplicado",  510,150, 18);
    stroke(0);
    arrow(x, y,mod*7,angle, g);
    
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "MagneticMaterials" });
  }
}
